%{

/****** This is an ICS parser generated by FLEX *************/
#include <stdlib.h>
#include <stdio.h>
#include <strings.h>

#include "icsdefs.h"

/*** filename ***/
static int __ics_parser_ndataset;
static char *__ics_parser_dataset;

/*** layout orders ***/
static int __ics_parser_norder;
static int __ics_parser_num_bits;

/*** layout sizes ***/
static int __ics_parser_nsizes;
static int __ics_parser_pix_size;
static int __ics_parser_x_size;
static int __ics_parser_y_size;
static int __ics_parser_z_size; 
static int __ics_parser_c_size;
static int __ics_parser_t_size;

static int __ics_parser_x_loc;
static int __ics_parser_y_loc;
static int __ics_parser_z_loc;
static int __ics_parser_c_loc;
static int __ics_parser_t_loc;

/*** format ***/

static int __ics_parser_nformat;
static int __ics_parser_is_float;
static int __ics_parser_is_unshort; // modified by hang Mar 21
static int __ics_parser_is_unint; // modified by hang Mar 21
static int __ics_parser_is_rgb;//  byte rgb 
static int __ics_parser_is_irgb;// int rgb
static int __ics_parser_is_srgb;// short rgb
static int __ics_parser_is_frgb;// float rgb
static int __ics_parser_is_rgba;// rgba(byte) 
static int __ics_parser_nbyte_order;
static int __ics_parser_is_big_endian;

%}

%option noyywrap

%s READLINE
%s FILENAME
%s LAYOUTORDER
%s LAYOUTSIZES
%s REPFORMAT
%s REPSIGN
%s REPBYTEORDER
word [^ \t\n]+
space [ \t]+

%%

<INITIAL>.|\n {;}
<INITIAL>[ \t]*filename {BEGIN FILENAME;}
<FILENAME>{word} {
   if(__ics_parser_ndataset==0) __ics_parser_dataset = strdup(yytext);
   __ics_parser_ndataset++;
}
<FILENAME>{space} {;}
<FILENAME>\n {BEGIN INITIAL;}

<INITIAL>[ \t]*layout{space}order {BEGIN LAYOUTORDER;}
<LAYOUTORDER>{space} {;}
<LAYOUTORDER>{word} {

  if (__ics_parser_norder==0) {
     if (!strcasecmp(yytext, "bits")) __ics_parser_num_bits=1;
     if (!strcasecmp(yytext, "bytes")) __ics_parser_num_bits=8;
  }
  if (__ics_parser_norder==1) {
     
     if (!strcasecmp(yytext, "x")) __ics_parser_x_loc=1;
     if (!strcasecmp(yytext, "y")) __ics_parser_y_loc=1;
     if (!strcasecmp(yytext, "z")) __ics_parser_z_loc=1;
     if (!strcasecmp(yytext, "c")) __ics_parser_c_loc=1;
     if (!strcasecmp(yytext, "t")) __ics_parser_t_loc=1;
  }
  if (__ics_parser_norder==2) {
     
    if (!strcasecmp(yytext, "x")) __ics_parser_x_loc=2;
    if (!strcasecmp(yytext, "y")) __ics_parser_y_loc=2;
    if (!strcasecmp(yytext, "z")) __ics_parser_z_loc=2;
    if (!strcasecmp(yytext, "c")) __ics_parser_c_loc=2;
    if (!strcasecmp(yytext, "t")) __ics_parser_t_loc=2;
  }
  if (__ics_parser_norder==3) {
    
    if (!strcasecmp(yytext, "x")) __ics_parser_x_loc=3;
    if (!strcasecmp(yytext, "y")) __ics_parser_y_loc=3;
    if (!strcasecmp(yytext, "z")) __ics_parser_z_loc=3;
    if (!strcasecmp(yytext, "c")) __ics_parser_c_loc=3;
    if (!strcasecmp(yytext, "t")) __ics_parser_t_loc=3;
  }
  if (__ics_parser_norder==4) {
    if (!strcasecmp(yytext, "x")) __ics_parser_x_loc=4;
    if (!strcasecmp(yytext, "y")) __ics_parser_y_loc=4;
    if (!strcasecmp(yytext, "z")) __ics_parser_z_loc=4;
    if (!strcasecmp(yytext, "c")) __ics_parser_c_loc=4;
    if (!strcasecmp(yytext, "t")) __ics_parser_t_loc=4;
     
  }
  if (__ics_parser_norder==5) {
     
    if (!strcasecmp(yytext, "x")) __ics_parser_x_loc=5;
    if (!strcasecmp(yytext, "y")) __ics_parser_y_loc=5;
    if (!strcasecmp(yytext, "z")) __ics_parser_z_loc=5;
    if (!strcasecmp(yytext, "c")) __ics_parser_c_loc=5;
    if (!strcasecmp(yytext, "t")) __ics_parser_t_loc=5;
  }
  
  __ics_parser_norder++;
}
<LAYOUTORDER>\n {BEGIN INITIAL;}

<INITIAL>[ \t]*layout{space}sizes {BEGIN LAYOUTSIZES;}
<LAYOUTSIZES>{space} {;}
<LAYOUTSIZES>{word} {
  switch(__ics_parser_nsizes) {
   case 0:
    __ics_parser_pix_size = atoi(yytext);
    break;
  case 1:
      if(__ics_parser_x_loc == 1 ) __ics_parser_x_size = atoi(yytext);
      if(__ics_parser_y_loc == 1 ) __ics_parser_y_size = atoi(yytext);
      if(__ics_parser_z_loc == 1 ) __ics_parser_z_size = atoi(yytext);
      if(__ics_parser_c_loc == 1 ) __ics_parser_c_size = atoi(yytext);
      if(__ics_parser_t_loc == 1 ) __ics_parser_t_size = atoi(yytext);
      break;
  case 2:
      if(__ics_parser_x_loc == 2 ) __ics_parser_x_size = atoi(yytext);
      if(__ics_parser_y_loc == 2 ) __ics_parser_y_size = atoi(yytext);
      if(__ics_parser_z_loc == 2 ) __ics_parser_z_size = atoi(yytext);
      if(__ics_parser_c_loc == 2 ) __ics_parser_c_size = atoi(yytext);
      if(__ics_parser_t_loc == 2 ) __ics_parser_t_size = atoi(yytext);
      break;
  case 3:
      //__ics_parser_z_size = atoi(yytext);
      if(__ics_parser_x_loc == 3 ) __ics_parser_x_size = atoi(yytext);
      if(__ics_parser_y_loc == 3 ) __ics_parser_y_size = atoi(yytext);
      if(__ics_parser_z_loc == 3 ) __ics_parser_z_size = atoi(yytext);
      if(__ics_parser_c_loc == 3 ) __ics_parser_c_size = atoi(yytext);
      if(__ics_parser_t_loc == 3 ) __ics_parser_t_size = atoi(yytext);
      break;
  case 4:
      if(__ics_parser_x_loc == 4 ) __ics_parser_x_size = atoi(yytext);
      if(__ics_parser_y_loc == 4 ) __ics_parser_y_size = atoi(yytext);
      if(__ics_parser_z_loc == 4 ) __ics_parser_z_size = atoi(yytext);
      if(__ics_parser_c_loc == 4 ) __ics_parser_c_size = atoi(yytext);
      if(__ics_parser_t_loc == 4 ) __ics_parser_t_size = atoi(yytext);
      break;
  case 5:
      if(__ics_parser_x_loc == 5 ) __ics_parser_x_size = atoi(yytext);
      if(__ics_parser_y_loc == 5 ) __ics_parser_y_size = atoi(yytext);
      if(__ics_parser_z_loc == 5 ) __ics_parser_z_size = atoi(yytext);
      if(__ics_parser_c_loc == 5 ) __ics_parser_c_size = atoi(yytext);
      if(__ics_parser_t_loc == 5 ) __ics_parser_t_size = atoi(yytext);
      break;
      default:
    ;

  }
  __ics_parser_nsizes++;
}
<LAYOUTSIZES>\n {BEGIN INITIAL;}

<INITIAL>[ \t]*representation{space}format {BEGIN REPFORMAT;}
<REPFORMAT>{space} {;}
<REPFORMAT>{word} {
  if (__ics_parser_nformat==0){

	__ics_parser_is_float = !strcasecmp(yytext,"float");
	__ics_parser_is_unshort = !strcasecmp(yytext,"unshort");
	__ics_parser_is_unint = !strcasecmp(yytext,"unint");
	__ics_parser_is_rgb = !strcasecmp(yytext,"rgb");
	__ics_parser_is_irgb = !strcasecmp(yytext,"irgb");
	__ics_parser_is_srgb = !strcasecmp(yytext,"srgb");
	__ics_parser_is_frgb = !strcasecmp(yytext,"frgb");
	__ics_parser_is_rgba = !strcasecmp(yytext,"rgba");
  }

  __ics_parser_nformat++;
}
<REPFORMAT>\n {BEGIN INITIAL;}
<INITIAL>[ \t]*representation{space}byte_order {BEGIN REPBYTEORDER;}
<REPBYTEORDER>{space} {;}
<REPBYTEORDER>{word} {
  if (__ics_parser_nbyte_order==0)
    __ics_parser_is_big_endian = (atoi(yytext)>1);
  __ics_parser_nbyte_order++;
}
<REPBYTEORDER>\n {BEGIN INITIAL;}
%%


int parse_ics_header_file(const char *icsfile, 
			  char **dataset, 
			  char **format, 
			  int *nx, int *ny, int *nz,
                          int *nc, int *nt,
			  int *is_big_endian)
{
  int nbytes;
  FILE *fp;

  *dataset = 0;
  *format = 0;
  *nx = 0;
  *ny = 0;
  *nz = 1;
  *nc = 0;
  *nt = 0;

  /*** dataset filename ***/
  __ics_parser_ndataset = 0;
  __ics_parser_dataset = 0;

  /*** layout orders ***/
   __ics_parser_norder = 0;
   __ics_parser_num_bits = 0;
   
   /*** layout sizes ***/
   __ics_parser_nsizes = 0;
   __ics_parser_pix_size = 0;
   __ics_parser_x_size = 0;
   __ics_parser_y_size = 0;
   __ics_parser_z_size = 1;
   //amina
   __ics_parser_c_size = 0;
   __ics_parser_t_size = 0;

   __ics_parser_x_loc = 0;
   __ics_parser_y_loc = 0;
   __ics_parser_z_loc = 0;
   //amina
   __ics_parser_c_loc = 0;
   __ics_parser_t_loc = 0;

   /*** format ***/
   __ics_parser_nformat = 0;
   __ics_parser_is_float = 0;

 // modified by hang Mar 21
   __ics_parser_is_unshort = 0;
   __ics_parser_is_unint = 0;

 // modified by hang Jan 05 08
   __ics_parser_is_rgb = 0;
   __ics_parser_is_irgb = 0;
   __ics_parser_is_srgb = 0;
   __ics_parser_is_frgb = 0;
   __ics_parser_is_rgba = 0;
   
   /*** endian: default is big-endian( for Solaris ) ***/
   __ics_parser_nbyte_order = 0;
   __ics_parser_is_big_endian = 1;

  if (!(fp = fopen(icsfile,"r"))) { 
    fprintf(stderr, "In parse_ics_header_file: \n");
    fprintf(stderr,"could not open %s\n", icsfile);
    return 0; /* failed */
  }
  yyin = fp;  
  yylex();
  fclose(fp); 


  nbytes = (__ics_parser_num_bits * __ics_parser_pix_size)>>3;
  *dataset = __ics_parser_dataset;
  *nx = __ics_parser_x_size;  
  *nz = __ics_parser_z_size;  
  *ny = __ics_parser_y_size;
  //amina
  *nc = __ics_parser_c_size;
  *nt = __ics_parser_t_size;
  *is_big_endian = __ics_parser_is_big_endian;
  
  
  // modified by hang Jan 05 08
  // should specify each type, not use combined condition, eg, !is_float && nbytes == sizeof(int) may confuse: int(4 bytes) and rgba(4 bytes)
  // before specify types, contact with Gerald for ics head parsing at database end
  if (__ics_parser_is_rgb ) { 
    *format = strdup("RGB");
    return 1;
  }
  if (__ics_parser_is_irgb ) { 
    *format = strdup("INTRGB");
    return 1;
  }
  if (__ics_parser_is_srgb ) { 
    *format = strdup("SHORTRGB");
    return 1;
  }
  if (__ics_parser_is_frgb ) { 
    *format = strdup("FLOATRGB");
    return 1;
  }
  if (__ics_parser_is_rgba ) { 
    *format = strdup("RGBA");
    return 1;
  }

  if (!__ics_parser_is_float && nbytes==sizeof(unsigned char)) { 
    *format = strdup("BYTE");
    return 1;
  }


  // modified by hang Mar 21
  if (__ics_parser_is_unshort) { 
      *format = strdup("USHORT");
      return 1;
  }
  else if (!__ics_parser_is_float && nbytes==sizeof(short)) { 
      *format = strdup("SHORT");
      return 1;
  }
  
  // modified by hang Mar 21
  if (__ics_parser_is_unint) { 
      *format = strdup("UINT");
      return 1;
  }
  else if (!__ics_parser_is_float && !__ics_parser_is_rgba && nbytes==sizeof(int)) { 
      *format = strdup("INT");
      return 1;
  }
  
  if (__ics_parser_is_float && nbytes==sizeof(float)) { 
      *format = strdup("FLOAT");
      return 1;
  }
  
  return 0;
}

