#include "global.h"
#include <iostream>
#include <cstdlib>
#include <sstream>
using namespace std;


namespace {
  template<class T>
  T fromString(const string& s)
  {
    istringstream in(s);
    T v;
    in >> v;
    return v;
  }
}

int stdi::toInt(std::string &s)
{
  return fromString<int>(s);
}

float stdi::toFloat(std::string &s)
{
  return fromString<float>(s);
}


string stdi::toString(const char *v)
{
  return string(v);
}

string stdi::toString(const string &v)
{
  return v;
}


string stdi::toString(int v)
{
  char buf[64];
  sprintf(buf, "%d\0", v);
  return string(buf);
}


string stdi::toString(float v)
{
  char buf[64];
  sprintf(buf, "%f\0", v);
  return string(buf);
}

string stdi::toString(double v)
{
  char buf[64];
  sprintf(buf, "%e\0", v);
  return string(buf);
}



int stdi::execSysCmd(const string &s)
{
  return system(s.c_str());
}

string stdi::getEnv(const string &name)
{
  return string(getenv(name.c_str()));
}


void stdi::reportBugInfo(const string &fun_name)
{
  cerr << "There is an unexpected bug in " << endl;
  cerr << "* " << fun_name << " *" << endl;
  cerr << "Please report to Q. Yang (email: qyang@media.lbl.gov)" << endl;
  cerr << "Thanks!" << endl;
}

